/******************************************************************************
*******************************************************************************

	Bubble Fight EX
	relminator
	http://rel.betterwebber.com


	Electric class


*******************************************************************************
******************************************************************************/


#include "Electric.h"


#define MIN_X ( -16 << 12 )
#define MIN_Y ( -16 << 12 )

#define MAX_ELECTRICS 16

//------------------------------------------------------------------------------
//	Electric Enemy
//------------------------------------------------------------------------------
Electric::Electric()
{
	Frame = 0;
	Active = false;
}

Electric::~Electric()
{
}

void Electric::Update()
{
	x += Dx;
	y += Dy;
	
	if( x < MIN_X )
	{
		Active = false;
		x = 300 << 12;
		y = 96 << 12;
	}
	
	Counter++;
	// animate
	if( ( Counter & 3 ) == 0 )
	{
		Frame = (Frame + 1) & 1;
		
	}

}


//------------------------------------------------------------------------------
//	Electric Container
//------------------------------------------------------------------------------
//--------------------------------------
//	Ctor and Dtor
//--------------------------------------
ElectricContainer::ElectricContainer()
{
}
	
ElectricContainer::~ElectricContainer()
{
	Electrics.clear();				// clear the bullets
}


void ElectricContainer::Init( int Palette, glImage* const Sprites )
{
	ColorTable = Palette;		// init needed data for drawing
	Images = Sprites;
	Electrics.resize( MAX_ELECTRICS/2 );			// 1/2 of max (speed of iteration)
	Electrics.reserve( MAX_ELECTRICS );		// reserve max for speed.  No need to do this for enemies
}

//--------------------------------------
//	Virtual Functions
//--------------------------------------
void ElectricContainer::UpdateEntities()
{
	
	std::vector<Electric>::iterator iter;
	for( iter = Electrics.begin(); iter != Electrics.end(); ++iter )
	{
		if( iter->Active )
			iter->Update();
	}
	
}

void ElectricContainer::DrawEntities()
{
	int bf = 59;
	 
	glColor( RGB15(31,31,31) );
	numEntities = 0;
	std::vector<Electric>::iterator iter;
	for( iter = Electrics.begin(); iter != Electrics.end(); ++iter )
	{
		if( iter->Active )
		{
			numEntities++;
			int flip = GL_FLIP_NONE;
			bool flipit = true;
			for( int i = 1; i < (192/16)-1; i+=2 )
			{
				if( (iter->Counter & 3) ==0 )flipit = !flipit;
				if(flipit)
					flip = GL_FLIP_H;
				else
					flip = GL_FLIP_NONE;
					
				glSprite( ((iter->x >> 12)) - 8, ((iter->y >> 12)+ i * 16) - 8, 
						  flip, &Images[bf+iter->Frame] 
						);
				glSprite( ((iter->x >> 12)) - 8, ((iter->y >> 12)+ i * 16+16) - 8, 
						  flip, &Images[bf+((iter->Frame+1) & 1)] 
						);
					
			}
			
			glSprite( ((iter->x >> 12)) - 8, ((iter->y >> 12)) - 8, 
					  GL_FLIP_NONE, &Images[57+iter->Frame] 
					);
		
			glSprite( ((iter->x >> 12)) - 8, ((iter->y >> 12)+16*11) - 8, 
					  GL_FLIP_V, &Images[57+iter->Frame] 
					);
		
		}
	}
	
}

bool ElectricContainer::Collide( StarFighter &Star )
{
	std::vector<Electric>::iterator iter;
	for( iter = Electrics.begin(); iter != Electrics.end(); ++iter )
	{
		if( iter->Active )
		{
			for( int i = 0; i < 6; i++)
			{
				int dist = abs((iter->x >> 12) - (Star.x >> 12) ); 
				if(  dist  < 8  )
				{
					if( !Star.IsBursting() )
					{
						// kill star
						if( !Star.IsInvincible() ) Star.Kill();
					}
					return true;
				}
			}
		}
	}
	return false;
}



void ElectricContainer::KillAllEntities()
{
	std::vector<Electric>::iterator iter;
	for( iter = Electrics.begin(); iter != Electrics.end(); ++iter )
	{
		if( iter->Active )
		{
			iter->Active = false;
			iter->x = 600 << 12;
			iter->y = 96 << 12;
		}
	}
	
}


//--------------------------------------
//	Non-Virtual Functions
//--------------------------------------
void ElectricContainer::Spawn( int _x, int _y )
{
	
	bool SlotFull = true;      		// value to check if all the slots are occupied
	
	std::vector<Electric>::iterator iter;
	for( iter = Electrics.begin(); iter != Electrics.end(); ++iter )
	{
		if( !iter->Active )		// insert a bullet on a free slot
		{

			iter->x = _x << 12;
			iter->y = _y << 12;
			iter->Dx = -floattof32( 0.3 );
			iter->Dy = 0;
			iter->Active = true;
			iter->Frame = 0;
			iter->Counter = 0;
			SlotFull = false;			// there's a free slot so we dont execute the code below
			break;
		
		}
	}
	
	// All the slots are full
	// Only push back a bullet if the slot is full and we have less than numbullets
	if( SlotFull && (Electrics.size() < MAX_ELECTRICS) )
	{
		Electric spark;
		spark.x = _x << 12;
		spark.y = _y << 12;
		spark.Dx = floattof32( 0.3 );
		spark.Dy = 0;
		spark.Active = true;
		spark.Frame = 0;
		spark.Counter = 0;
		
		Electrics.push_back(spark);
	}
	
}

