/******************************************************************************
*******************************************************************************

	Bubble Fight EX
	relminator
	http://rel.betterwebber.com


	Plato class


*******************************************************************************
******************************************************************************/

#include <nds.h>
#include <vector>
#include "Vector2df32.h"

#include "EntityContainer.h"
#include "StarFighter.h"
#include "Explosion.h"

#ifndef PLATO_H
#define PLATO_H

//------------------------------------------------------------------------------
//	Plato Enemy
//------------------------------------------------------------------------------
class Plato 
{

public:
	friend class PlatoContainer;
	
	Plato();
	~Plato();
	void Update();
	
private:
	s32		x;
	s32		y;
	s32		Dx;
	s32		Dy;
	s32		Speed;
	bool 	Flipped;
	int		Frame;
	int 	Counter;
	bool	Active;
	int 	Hp;
	
	EN_DRAW_MODE DrawMode;
	
	
};

//------------------------------------------------------------------------------
//	Plato Container
//------------------------------------------------------------------------------
class PlatoContainer : public EntityContainer
{	

public:

	PlatoContainer();
    ~PlatoContainer();
	void Init(int Palette, glImage* const Sprites );
    virtual void UpdateEntities();
	virtual void DrawEntities();
	virtual bool Collide( StarFighter &Star );
	virtual void KillAllEntities();
	virtual int NumEntities() 
	{
		return numEntities;
	}
	
	void Spawn( int _x, int _y, s32 _speed, int _counter ,bool _flip, int _frame );
	
private:
	int numEntities;
	
	glImage *Images;
	int ColorTable;
	
	std::vector<Plato> Platos;
	
	
};

#endif // PLATO_H
