/******************************************************************************
*******************************************************************************

	Bubble Fight EX
	relminator
	http://rel.betterwebber.com


	Popcorn class


*******************************************************************************
******************************************************************************/

#include <nds.h>
#include <vector>
#include "Vector2df32.h"

#include "Spline.h"
#include "EntityContainer.h"
#include "StarFighter.h"
#include "Explosion.h"

#ifndef POPCORN_H
#define POPCORN_H

//------------------------------------------------------------------------------
//	Popcorn Enemy
//------------------------------------------------------------------------------
class Popcorn 
{

public:
	friend class PopcornContainer;
	
	Popcorn();
	~Popcorn();
	void Update();
	void LoadPath( int _sx, int _sy, int _ex, int _ey );
	
private:
	s32		x;
	s32		y;
	int		Frame;
	int 	Counter;
	bool	Active;
	int 	Hp;
	
	EN_DRAW_MODE DrawMode;
	
	Spline Path;

};

//------------------------------------------------------------------------------
//	Popcorn Container
//------------------------------------------------------------------------------
class PopcornContainer : public EntityContainer
{	

public:

	PopcornContainer();
    ~PopcornContainer();
	void Init(int Palette, glImage* const Sprites );
    virtual void UpdateEntities();
	virtual void DrawEntities();
	virtual bool Collide( StarFighter &Star );
	virtual void KillAllEntities();
	void Spawn(  int _x, int _y, s32 speed, int _radius );
	virtual int NumEntities() 
	{
		return numEntities;
	}
	
private:
	int numEntities;
	
	glImage *Images;
	int ColorTable;
	
	std::vector<Popcorn> Popcorns;
	
	
};

#endif // POPCORN_H
