/******************************************************************************
*******************************************************************************

	Bubble Fight EX
	relminator
	http://rel.betterwebber.com


	Waver class


*******************************************************************************
******************************************************************************/

#include <nds.h>
#include <vector>
#include "Vector2df32.h"

#include "EntityContainer.h"
#include "StarFighter.h"
#include "Explosion.h"

#ifndef WAVER_H
#define WAVER_H

//------------------------------------------------------------------------------
//	Waver Enemy
//------------------------------------------------------------------------------
class Waver 
{

public:
	friend class WaverContainer;
	
	Waver();
	~Waver();
	void Update();
	
private:
	s32		x;
	s32		y;
	s32		Dx;
	s32		Dy;
	s32		Sy;
	s32		Angle;
	int 	Radius;
	int		Frame;
	int 	Counter;
	bool	Active;
	int 	Hp;
	
	EN_DRAW_MODE DrawMode;
	
	
};

//------------------------------------------------------------------------------
//	Waver Container
//------------------------------------------------------------------------------
class WaverContainer : public EntityContainer
{	

public:

	WaverContainer();
    ~WaverContainer();
	void Init(int Palette, glImage* const Sprites );
    virtual void UpdateEntities();
	virtual void DrawEntities();
	virtual bool Collide( StarFighter &Star );
	virtual void KillAllEntities();
	virtual int NumEntities() 
	{
		return numEntities;
	}
	
	void Spawn( int _x, int _y, s32 _speed, s32 _angle, int _radius, bool _flip, int _frame );
	
private:
	int numEntities;
	
	glImage *Images;
	int ColorTable;
	
	std::vector<Waver> Wavers;
	
	
};

#endif // WAVER_H
